0323cb4b513cfefa0728d42ce5133f1ef95d4781
[osm/RO.git] / scripts / install-openmano.sh
1 #!/bin/bash
2
3 ##
4 # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5 # This file is part of openmano
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License"); you may
9 # not use this file except in compliance with the License. You may obtain
10 # a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16 # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17 # License for the specific language governing permissions and limitations
18 # under the License.
19 #
20 # For those usages not covered by the Apache License, Version 2.0 please
21 # contact with: nfvlabs@tid.es
22 ##
23
24 #ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7
25 #Get needed packages, source code and configure to run openmano
26 #Ask for database user and password if not provided
27
28 function usage(){
29 echo -e "usage: sudo $0 [OPTIONS]"
30 echo -e "Install last stable source code in ./openmano and the needed packages"
31 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
32 echo -e " OPTIONS"
33 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
34 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
35 echo -e " -q --quiet: install in unattended mode"
36 echo -e " -h --help: show this help"
37 echo -e " --develop: install last version for developers, and do not configure as a service"
38 echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one"
39 echo -e " --updatedb: do not reinstall mano_db DB if it exists, just update database"
40 echo -e " --force: makes idenpotent, delete previous installations folders if needed. It assumes --updatedb if --forcedb option is not provided"
41 echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo"
42 echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation"
43 echo -e " --no-db: do not install mysql server"
44 }
45
46 function install_packages(){
47 [ -x /usr/bin/apt-get ] && apt-get install -y $*
48 [ -x /usr/bin/yum ] && yum install -y $*
49
50 #check properly installed
51 for PACKAGE in $*
52 do
53 PACKAGE_INSTALLED="no"
54 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
55 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
56 if [ "$PACKAGE_INSTALLED" = "no" ]
57 then
58 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
59 exit 1
60 fi
61 done
62 }
63
64 function ask_user(){
65 # ask to the user and parse a response among 'y', 'yes', 'n' or 'no'. Case insensitive
66 # Params: $1 text to ask; $2 Action by default, can be 'y' for yes, 'n' for no, other or empty for not allowed
67 # Return: true(0) if user type 'yes'; false (1) if user type 'no'
68 read -e -p "$1" USER_CONFIRMATION
69 while true ; do
70 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'y' ] && return 0
71 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'n' ] && return 1
72 [ "${USER_CONFIRMATION,,}" == "yes" ] || [ "${USER_CONFIRMATION,,}" == "y" ] && return 0
73 [ "${USER_CONFIRMATION,,}" == "no" ] || [ "${USER_CONFIRMATION,,}" == "n" ] && return 1
74 read -e -p "Please type 'yes' or 'no': " USER_CONFIRMATION
75 done
76 }
77
78 GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
79 GIT_OVIM_URL=https://osm.etsi.org/gerrit/osm/openvim.git
80 DBUSER="root"
81 DBPASSWD=""
82 DBPASSWD_PARAM=""
83 QUIET_MODE=""
84 DEVELOP=""
85 DB_FORCE_UPDATE=""
86 UPDATEDB=""
87 FORCE=""
88 NOCLONE=""
89 NO_PACKAGES=""
90 NO_DB=""
91
92 while getopts ":u:p:hiq-:" o; do
93 case "${o}" in
94 u)
95 export DBUSER="$OPTARG"
96 ;;
97 p)
98 export DBPASSWD="$OPTARG"
99 export DBPASSWD_PARAM="-p$OPTARG"
100 ;;
101 q)
102 export QUIET_MODE=yes
103 export DEBIAN_FRONTEND=noninteractive
104 ;;
105 h)
106 usage && exit 0
107 ;;
108 -)
109 [ "${OPTARG}" == "help" ] && usage && exit 0
110 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
111 [ "${OPTARG}" == "forcedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--forcedb" && continue
112 [ "${OPTARG}" == "updatedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--updatedb" && continue
113 [ "${OPTARG}" == "force" ] && FORCE="y" && continue
114 [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue
115 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
116 [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue
117 [ "${OPTARG}" == "no-db" ] && NO_DB="y" && continue
118 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
119 exit 1
120 ;;
121 \?)
122 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
123 exit 1
124 ;;
125 :)
126 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
127 exit 1
128 ;;
129 *)
130 usage >&2
131 exit 1
132 ;;
133 esac
134 done
135
136 if [ "$DB_FORCE_UPDATE" == "--forcedb--updatedb" ] || [ "$DB_FORCE_UPDATE" == "--updatedb--forcedb" ] ; then
137 echo "Error: options --forcedb and --updatedb are mutually exclusive" >&2
138 exit 1
139 elif [ -n "$FORCE" ] && [ -z "$DB_FORCE_UPDATE" ] ; then
140 DB_FORCE_UPDATE="--updatedb"
141 fi
142
143 #check root privileges and non a root user behind
144 [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
145 if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
146 then
147 [[ -z $QUIET_MODE ]] && ! ask_user "Install in the root user (y/N)? " n && echo "Cancelled" && exit 1
148 export SUDO_USER=root
149 fi
150
151 # Discover Linux distribution
152 # try redhat type
153 [ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
154 # if not assuming ubuntu type
155 [ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
156 if [ "$_DISTRO" == "Ubuntu" ]
157 then
158 _RELEASE=$(lsb_release -rs)
159 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
160 then
161 [[ -z $QUIET_MODE ]] &&
162 ! ask_user "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)' (y/N)? " n &&
163 echo "Cancelled" && exit 1
164 _RELEASE = 14
165 fi
166 elif [ "$_DISTRO" == "CentOS" ]
167 then
168 _RELEASE="7"
169 if ! cat /etc/redhat-release | grep -q "7."
170 then
171 [[ -z $QUIET_MODE ]] &&
172 ! ask_user "WARNING! Not tested CentOS version. Continue assuming a '$_RELEASE' type (y/N)? " n &&
173 echo "Cancelled" && exit 1
174 fi
175 elif [ "$_DISTRO" == "Red" ]
176 then
177 _RELEASE="7"
178 if ! cat /etc/redhat-release | grep -q "7."
179 then
180 [[ -z $QUIET_MODE ]] &&
181 ! ask_user "WARNING! Not tested Red Hat OS version. Continue assuming a '$_RELEASE' type (y/N)? " n &&
182 echo "Cancelled" && exit 1
183 fi
184 else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
185 _DISTRO_DISCOVER=$_DISTRO
186 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
187 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
188 [[ -z $QUIET_MODE ]] &&
189 ! ask_user "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type (y/N)? " n &&
190 echo "Cancelled" && exit 1
191 fi
192
193 #check if installed as a service
194 INSTALL_AS_A_SERVICE=""
195 [[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y"
196
197 # Next operations require knowing BASEFOLDER
198 if [[ -z "$NOCLONE" ]]; then
199 if [[ -n "$INSTALL_AS_A_SERVICE" ]] ; then
200 BASEFOLDER=__openmano__${RANDOM}
201 else
202 BASEFOLDER="${PWD}/openmano"
203 fi
204 [[ -n "$FORCE" ]] && rm -rf $BASEFOLDER #make idempotent
205 else
206 HERE=$(dirname $(readlink -f ${BASH_SOURCE[0]}))
207 BASEFOLDER=$(dirname $HERE)
208 fi
209
210 if [[ -z "$NO_PACKAGES" ]]
211 then
212 echo -e "\n"\
213 "#################################################################\n"\
214 "##### UPDATE REPOSITORIES #####\n"\
215 "#################################################################"
216 [ "$_DISTRO" == "Ubuntu" ] && apt-get update -y
217
218 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
219 [ "$_DISTRO" == "CentOS" ] && sudo yum install -y epel-release
220 [ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
221 && sudo rpm -ivh epel-release-7-5.noarch.rpm && sudo yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
222 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && sudo yum repolist
223
224 echo -e "\n"\
225 "#################################################################\n"\
226 "##### INSTALL REQUIRED PACKAGES #####\n"\
227 "#################################################################"
228 [ "$_DISTRO" == "Ubuntu" ] && install_packages "git make screen wget mysql-client"
229 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git make screen wget mariadb-client"
230
231 echo -e "\n"\
232 "#################################################################\n"\
233 "##### INSTALL PYTHON PACKAGES #####\n"\
234 "#################################################################"
235 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev python-pip"
236 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel python-pip"
237 # The only way to install python-bottle on Centos7 is with easy_install or pip
238 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
239
240 # required for vmware connector TODO move that to separete opt in install script
241 sudo pip install --upgrade pip
242 sudo pip install pyvcloud
243 sudo pip install progressbar
244 sudo pip install prettytable
245 sudo pip install pyvmomi
246
247 # required for AWS connector
248 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-boto"
249 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-boto" #TODO check if at Centos it exists with this name, or PIP should be used
250
251 # install openstack client needed for using openstack as a VIM
252 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient"
253 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient #TODO revise if gcc python-pip is needed
254 fi # [[ -z "$NO_PACKAGES" ]]
255
256 if [[ -z $NOCLONE ]]; then
257 echo -e "\n"\
258 "#################################################################\n"\
259 "##### DOWNLOAD SOURCE #####\n"\
260 "#################################################################"
261 if [[ -d "${BASEFOLDER}" ]] ; then
262 if [[ -n "$FORCE" ]] ; then
263 echo "deleting '${BASEFOLDER}' folder"
264 rm -rf "$BASEFOLDER" #make idempotent
265 elif [[ -z "$QUIET_MODE" ]] ; then
266 ! ask_user "folder '${BASEFOLDER}' exists, overwrite (y/N)? " n && echo "Cancelled!" && exit 1
267 rm -rf "$BASEFOLDER"
268 else
269 echo "'${BASEFOLDER}' folder exists. Use "--force" to overwrite" >&2 && exit 1
270 fi
271 fi
272 su $SUDO_USER -c "git clone ${GIT_URL} ${BASEFOLDER}"
273 LATEST_STABLE_TAG=`git -C "${BASEFOLDER}" tag -l v[0-9].* | tail -n1`
274 [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${BASEFOLDER} checkout tags/${LATEST_STABLE_TAG}"
275 su $SUDO_USER -c "cp ${BASEFOLDER}/.gitignore-common ${BASEFOLDER}/.gitignore"
276 fi
277
278 echo -e "\n"\
279 "#################################################################\n"\
280 "##### INSTALLING OVIM LIBRARY #####\n"\
281 "#################################################################"
282 su $SUDO_USER -c "git -C ${BASEFOLDER} clone ${GIT_OVIM_URL} openvim"
283 [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${BASEFOLDER}/openvim checkout v2.0"
284
285 # Install debian dependencies before setup.py
286 [ "$_DISTRO" == "Ubuntu" ] && install_packages "libmysqlclient-dev"
287 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "libmysqlclient-dev" #TODO check if that's the name in CentOS and RedHat
288 make -C ${BASEFOLDER}/openvim lite
289 rm -rf "${BASEFOLDER}/openvim"
290 OSMLIBOVIM_PATH=`python -c 'import lib_osm_openvim; print lib_osm_openvim.__path__[0]'`
291
292 if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
293 then
294 echo -e "\n"\
295 "#################################################################\n"\
296 "##### CONFIGURE firewalld #####\n"\
297 "#################################################################"
298 if [[ -z $QUIET_MODE ]] || ask_user "Configure firewalld for openmanod port 9090 (Y/n)? " y
299 then
300 #Creates a service file for openmano
301 echo '<?xml version="1.0" encoding="utf-8"?>
302 <service>
303 <short>openmanod</short>
304 <description>openmanod service</description>
305 <port protocol="tcp" port="9090"/>
306 </service>' > /etc/firewalld/services/openmanod.xml
307 #put proper permissions
308 pushd /etc/firewalld/services > /dev/null
309 restorecon openmanod.xml
310 chmod 640 openmanod.xml
311 popd > /dev/null
312 #Add the openmanod service to the default zone permanently and reload the firewall configuration
313 firewall-cmd --permanent --add-service=openmanod > /dev/null
314 firewall-cmd --reload > /dev/null
315 echo "done."
316 else
317 echo "skipping."
318 fi
319 fi
320
321 echo -e "\n"\
322 "#################################################################\n"\
323 "##### CONFIGURE OPENMANO CLIENT #####\n"\
324 "#################################################################"
325 #creates a link at ~/bin if not configured as a service
326 if [[ -z "$INSTALL_AS_A_SERVICE" ]]
327 then
328 su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
329 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
330 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report'
331 su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
332 su $SUDO_USER -c "ln -s '${BASEFOLDER}/openmano' "'${HOME}/bin/openmano'
333 su $SUDO_USER -c "ln -s '${BASEFOLDER}/scripts/openmano-report.sh' "'${HOME}/bin/openmano-report'
334 su $SUDO_USER -c "ln -s '${BASEFOLDER}/scripts/service-openmano' "'${HOME}/bin/service-openmano'
335
336 #insert /home/<user>/bin in the PATH
337 #skiped because normally this is done authomatically when ~/bin exists
338 #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
339 #then
340 # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
341 # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
342 #fi
343
344 if [[ $SUDO_USER == root ]]
345 then
346 if ! echo $PATH | grep -q "${HOME}/bin"
347 then
348 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
349 fi
350 fi
351 fi
352
353 #configure arg-autocomplete for this user
354 #in case of minimal instalation this package is not installed by default
355 [[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
356 #su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
357 su $SUDO_USER -c 'activate-global-python-argcomplete --user'
358 if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
359 then
360 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
361 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
362 fi
363
364 if [ -z "$NO_DB" ]; then
365 echo -e "\n"\
366 "#################################################################\n"\
367 "##### INSTALL DATABASE SERVER #####\n"\
368 "#################################################################"
369
370 if [ -n "$QUIET_MODE" ]; then
371 DB_QUIET='-q'
372 fi
373 ${BASEFOLDER}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} $DB_QUIET $DB_FORCE_UPDATE || exit 1
374 echo -e "\n"\
375 "#################################################################\n"\
376 "##### CREATE AND INIT MANO_VIM DATABASE #####\n"\
377 "#################################################################"
378 # Install mano_vim_db after setup
379 ${OSMLIBOVIM_PATH}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} -u mano -p manopw -d mano_vim_db --no-install-packages $DB_QUIET $DB_FORCE_UPDATE || exit 1
380 fi # [ -z "$NO_DB" ]
381
382 if [[ -n "$INSTALL_AS_A_SERVICE" ]]
383 then
384 echo -e "\n"\
385 "#################################################################\n"\
386 "##### CONFIGURE OPENMANO SERVICE #####\n"\
387 "#################################################################"
388
389 ${BASEFOLDER}/scripts/install-openmano-service.sh -f ${BASEFOLDER} `[[ -z "$NOCLONE" ]] && echo "-d"`
390 # rm -rf ${BASEFOLDER}
391 # alias service-openmano="service openmano"
392 # echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
393 echo
394 echo "Done! installed at /opt/openmano"
395 echo " Manage server with 'sudo service osm-ro start|stop|status|...' "
396 else
397 echo
398 echo "Done! you may need to logout and login again for loading client configuration"
399 echo " Run './${BASEFOLDER}/scripts/service-openmano start' for starting openmano in a screen"
400 fi